
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Story_viewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const story_views = await db.story_views.create(
            {
                id: data.id || undefined,
        
        viewed_at: data.viewed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await story_views.setStory( data.story || null, {
            transaction,
        });
        
        await story_views.setViewer( data.viewer || null, {
            transaction,
        });
        

        

        

        return story_views;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const story_viewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                viewed_at: item.viewed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const story_views = await db.story_views.bulkCreate(story_viewsData, { transaction });

        // For each item created, replace relation files
        

        return story_views;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const story_views = await db.story_views.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.viewed_at !== undefined) updatePayload.viewed_at = data.viewed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await story_views.update(updatePayload, {transaction});

        
        
        if (data.story !== undefined) {
            await story_views.setStory(
              
              data.story,
              
              { transaction }
            );
        }
        
        if (data.viewer !== undefined) {
            await story_views.setViewer(
              
              data.viewer,
              
              { transaction }
            );
        }
        

        
        

        

        return story_views;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const story_views = await db.story_views.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of story_views) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of story_views) {
                await record.destroy({transaction});
            }
        });


        return story_views;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const story_views = await db.story_views.findByPk(id, options);

        await story_views.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await story_views.destroy({
            transaction
        });

        return story_views;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const story_views = await db.story_views.findOne(
            { where },
            { transaction },
        );

        if (!story_views) {
            return story_views;
        }

        const output = story_views.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.story = await story_views.getStory({
            transaction
        });
        
        
        output.viewer = await story_views.getViewer({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stories,
        as: 'story',
        
        where: filter.story ? {
          [Op.or]: [
            { id: { [Op.in]: filter.story.split('|').map(term => Utils.uuid(term)) } },
            {
              caption: {
                [Op.or]: filter.story.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'viewer',
        
        where: filter.viewer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.viewer.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.viewer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.viewed_atRange) {
                const [start, end] = filter.viewed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    viewed_at: {
                    ...where.viewed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    viewed_at: {
                    ...where.viewed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.story_views.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'story_views',
                        'viewed_at',
                        query,
                    ),
                ],
            };
        }

        const records = await db.story_views.findAll({
            attributes: [ 'id', 'viewed_at' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['viewed_at', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.viewed_at,
        }));
    }

    
};

